// Arguments passed into this controller can be accessed via the `$.args` object directly or:
var args = $.args;

var MapModule = require('ti.map');
var map;
var legs = args.legs;

var annotations = [];

function open() {
    loadAnnotations();
}

function loadAnnotations(){
	
	// Instead of using default pins, I use customViews. These Views contain an ImageView and a Label
	for (var i = 0; i < legs.length ; i++) 
	{
		var view = Ti.UI.createView({
			height: Ti.UI.SIZE,
			width: Ti.UI.SIZE
		});
		
		var imgView = Ti.UI.createImageView({
			image : "/images/pin_red.png"
		});
		
		var number = Ti.UI.createLabel({
			text: (i+1),
			top: "10%"
		});
		
		view.add(imgView);
		view.add(number);
		
		var annotation = MapModule.createAnnotation({
	        latitude : legs[i].start_location.lat,
	        longitude : legs[i].start_location.lng,
	        title: legs[i].start_address,
	        id : i,
	        customView: view
	    });
	   	
	   	annotations.push(annotation);
	   	
	   	// Last pin
	   	if (i == legs.length-1)
	   	{
	   		var viewDest = Ti.UI.createView({
				height: Ti.UI.SIZE,
				width: Ti.UI.SIZE
			});
			
			var imgViewDest = Ti.UI.createImageView({
				image : "/images/pin_red.png"
			});
			
			var numberDest = Ti.UI.createLabel({
				text: (i+2),
				top: "10%"
			});
			
			viewDest.add(imgViewDest);
			viewDest.add(numberDest);
	   		
			var annotationDest = MapModule.createAnnotation({
			    latitude : legs[legs.length-1].end_location.lat,
			    longitude : legs[legs.length-1].end_location.lng,
			    title: legs[legs.length-1].end_address,
			    id : legs.length-1,
			    customView: viewDest
			});
			annotations.push(annotationDest);
			
			loadMap();
	   	}
	}
}

function loadMap() {
	
	var rc = MapModule.isGooglePlayServicesAvailable();
	switch (rc) {
	    case MapModule.SUCCESS:
	        Ti.API.info('Google Play services is installed.');
	        break;
	    case MapModule.SERVICE_MISSING:
	        alert('Google Play services is missing. Please install Google Play services from the Google Play store.');
	        break;
	    case MapModule.SERVICE_VERSION_UPDATE_REQUIRED:
	        alert('Google Play services is out of date. Please update Google Play services.');
	        break;
	    case MapModule.SERVICE_DISABLED:
	        alert('Google Play services is disabled. Please enable Google Play services.');
	        break;
	    case MapModule.SERVICE_INVALID:
	        alert('Google Play services cannot be authenticated. Reinstall Google Play services.');
	        break;
	    default:
	        alert('Unknown error.');
	}
	
	map = MapModule.createView({
	    top: 0,
	    height: Ti.UI.FILL,
	    width: Ti.UI.FILL,
	    userLocation: true,
	    userLocationButton: false,
	    region : { latitude: legs[0].start_location.lat, longitude: legs[0].start_location.lng, latitudeDelta: 0.2, longitudeDelta: 0.2 },
	    mapToolbarEnabled : false
	});
	
	map.addAnnotations(annotations);
	
	$.mapView.add(map);
}